# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_with example
%bcond_without repolib

%global arch_name %{_target_os}-%{_target_cpu}

%define section free

Name:           hawtjni
Version:        1.5
Release:        3%{?dist}
Epoch:          0
Summary:        HawtJNI
License:        ASL 2.0
URL:            http://hawtjni.fusesource.org
Group:          Development/Libraries/Java
%if 0
git clone -n -q https://github.com/fusesource/hawtjni.git && cd hawtjni && git checkout hawtjni-project-1.5 && rm -rf .git && cd .. && mv hawtjni hawtjni-1.5 && tar cjf hawtjni-1.5.tar.bz2 hawtjni-1.5
%endif
Source0:        %{name}-%{version}.tar.bz2
Patch0:         hawtjni-plexus-archiver-unarchiver.patch
Patch1:         hawtjni-pom.patch
Patch2:         hawtjni-ac-prereq.patch
Patch3:         hawtjni-asm.patch
Patch4:         hawtjni-classified.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
%if %with example
Requires:       %{name}-example-native = %{epoch}:%{version}-%{release}
%endif
Requires:       jpackage-utils
Requires:       autoconf
Requires:       automake
Requires:       libtool
Requires:       maven2-plugin-eclipse
Requires:       maven2-plugin-idea
Requires:       maven2-plugin-shade
Requires:       objectweb-asm
Requires:       plexus-io
Requires:       fusesource-pom >= 0:1.8
BuildRequires:  apache-commons-parent
%if %with example
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
%endif
BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-shade
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  objectweb-asm >= 0:3.3.1
BuildRequires:  plexus-io
BuildRequires:  fusesource-pom >= 0:1.8
%if %without example
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
A JNI code generator based on the JNI generator used by the eclipse SWT
project.

%if %with example
%package example-%{arch_name}
Summary:        Native jar for %{name}
Group:          Development/Documentation
Provides:       %{name}-example-native = %{epoch}:%{version}-%{release}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description example-%{arch_name}
%{summary}.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if 0
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p0 -b .sav0
%if %without example
%patch1 -p0 -b .sav1
%endif
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4

%build
# FIXME: this should not be necessary
export MAVEN_OPTS="-Xbootclasspath/p:`pwd`/hawtjni-runtime/target/hawtjni-runtime-%{version}.jar"
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
%{_bindir}/mvn-jpp -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=oss-releases::default::file://`pwd`/maven2-brew deploy javadoc:aggregate

%install
rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms

%if %with example
cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-example/%{version}/hawtjni-example-%{version}-linux*.jar %{buildroot}%{_javadir}/
cp maven2-brew/org/fusesource/hawtjni/hawtjni-example/%{version}/hawtjni-example-%{version}-native-src.zip %{buildroot}%{_javadir}/
cp maven2-brew/org/fusesource/hawtjni/hawtjni-example/%{version}/hawtjni-example-%{version}.jar %{buildroot}%{_javadir}/
cp maven2-brew/org/fusesource/hawtjni/hawtjni-example/%{version}/hawtjni-example-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-hawtjni-example.pom
%add_to_maven_depmap org.fusesource.hawtjni hawtjni-example %{version} JPP hawtjni-example
%endif

cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-generator/%{version}/hawtjni-generator-%{version}.jar %{buildroot}%{_javadir}/
cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-generator/%{version}/hawtjni-generator-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-hawtjni-generator.pom
%add_to_maven_depmap org.fusesource.hawtjni hawtjni-generator %{version} JPP hawtjni-generator

cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-project/%{version}/hawtjni-project-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-hawtjni-project.pom
%add_to_maven_depmap org.fusesource.hawtjni hawtjni-project %{version} JPP hawtjni-project

cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-runtime/%{version}/hawtjni-runtime-%{version}.jar %{buildroot}%{_javadir}/
cp -p maven2-brew/org/fusesource/hawtjni/hawtjni-runtime/%{version}/hawtjni-runtime-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-hawtjni-runtime.pom
%add_to_maven_depmap org.fusesource.hawtjni hawtjni-runtime %{version} JPP hawtjni-runtime

cp -p maven2-brew/org/fusesource/hawtjni/maven-hawtjni-plugin/%{version}/maven-hawtjni-plugin-%{version}.jar %{buildroot}%{_javadir}/
cp -p maven2-brew/org/fusesource/hawtjni/maven-hawtjni-plugin/%{version}/maven-hawtjni-plugin-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-maven-hawtjni-plugin.pom
%add_to_maven_depmap org.fusesource.hawtjni maven-hawtjni-plugin %{version} JPP maven-hawtjni-plugin

(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if 0
# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{version}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{version}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{version}/apidocs
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%if %with example
%{_javadir}*/hawtjni-example-%{version}-native-src.zip
%{_javadir}*/hawtjni-example-native-src.zip
%{_javadir}*/hawtjni-example-%{version}.jar
%{_javadir}*/hawtjni-example.jar
%endif
%{_javadir}*/maven-hawtjni-plugin-%{version}.jar
%{_javadir}*/maven-hawtjni-plugin.jar
%{_javadir}*/hawtjni-generator-%{version}.jar
%{_javadir}*/hawtjni-generator.jar
%{_javadir}*/hawtjni-runtime-%{version}.jar
%{_javadir}*/hawtjni-runtime.jar
%if %with example
%{_datadir}/maven2/poms/JPP-hawtjni-example.pom
%endif
%{_datadir}/maven2/poms/JPP-hawtjni-generator.pom
%{_datadir}/maven2/poms/JPP-hawtjni-project.pom
%{_datadir}/maven2/poms/JPP-hawtjni-runtime.pom
%{_datadir}/maven2/poms/JPP-maven-hawtjni-plugin.pom
%{_mavendepmapfragdir}/%{name}

%if %with example
%files example-%{arch_name}
%defattr(0644,root,root,0755)
%{_javadir}*/hawtjni-example-%{version}-linux*.jar
%{_javadir}*/hawtjni-example-linux*.jar
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if 0
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}    
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Dec 14 2011 David Walluck <dwalluck@redhat.com> 0:1.5-3
- set classified=true

* Wed Dec 14 2011 David Walluck <dwalluck@redhat.com> 0:1.5-2
- work around maven deploy bug

* Wed Dec 14 2011 David Walluck <dwalluck@redhat.com> 0:1.5-1
- 1.5

* Tue Dec 13 2011 David Walluck <dwalluck@redhat.com> 0:1.1-6
- use flat dir
- fix repolib file list
- fix BuildRequires
- disable example (helps bootstrap)

* Mon Jan 03 2011 David Walluck <dwalluck@redhat.com> 0:1.1-5
- fix example name
- change jar location

* Mon Dec 20 2010 David Walluck <dwalluck@redhat.com> 0:1.1-4
- make this an arch package
- make example optional
- fix objectweb-asm version

* Mon Dec 20 2010 David Walluck <dwalluck@redhat.com> 0:1.1-3
- fix maven-hawtjni-plugin depmap entry

* Mon Dec 20 2010 David Walluck <dwalluck@redhat.com> 0:1.1-2
- fix Summary and description and URL

* Mon Dec 20 2010 David Walluck <dwalluck@redhat.com> 0:1.1-1
- release
